package pl.elzab.virtualcomsample.activity;

import android.content.Intent;
import android.os.Bundle;
import android.util.Log;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.widget.Button;
import android.widget.TextView;
import java.util.LinkedList;
import pl.elzab.virtualcomsample.R;
import pl.elzab.virtualcomsample.Communication;
import pl.elzab.virtualcomsample.dataobject.StxReceiptPosition;

/**
 * Activity used to test Elzab D10 printer or Elzab Zeta printer.
 * @author ElzabSoft
 * @version 1.01
 */
public class ZetaD10TestActivity extends UsbSerialActivity {
    /** button to obtain unique number */
    Button mButtonUniqueNr;
    /** button to print receipt */
    Button mButtonReceiptPrint;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_zeta_d10_test);

        showListOnScreen();
        mDeviceOutputText = (TextView)findViewById(R.id.deviceOutputText);

        mButtonUniqueNr = (Button)findViewById(R.id.buttonUniqueNr);
        mButtonUniqueNr.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View arg0) {
                Log.d(TAG, "Clicked button for obtaining device's unique number.");
                mDeviceOutputText.setText("");
                mCommunication.stxGetUniqueNumber();
            }
        }
        );

        mButtonReceiptPrint = (Button)findViewById(R.id.buttonReceiptPrint);
        mButtonReceiptPrint.setOnClickListener(new View.OnClickListener() {
           @Override
           public void onClick(View arg0) {
               Log.d(TAG, "Clicked button for printing receipt.");
               mDeviceOutputText.setText("");
               String quantityUnit = "sztuka";
               LinkedList<StxReceiptPosition> list = new LinkedList<StxReceiptPosition>();
               list.addLast(new StxReceiptPosition("Towar #1", quantityUnit, 1.0f, 0.01f));
               list.addLast(new StxReceiptPosition("Towar #2", quantityUnit, 1.0f, 0.01f));
               list.addLast(new StxReceiptPosition("Towar #3", quantityUnit, 1.0f, 0.01f));
               mCommunication.stxPrintReceipt(list);
           }
       });

        // back, close the connection
        Button buttonBack = (Button)findViewById(R.id.buttonBack);
        buttonBack.setOnClickListener(new View.OnClickListener() {
                                          @Override
                                          public void onClick(View arg0) {
                                              Intent intent = new Intent(ZetaD10TestActivity.this, DeviceSelectionActivity.class);
                                              startActivity(intent);
                                              finish();
                                          }
                                      }
        );

        mCommunication = new Communication(this);
    }

    @Override
    public boolean onCreateOptionsMenu(Menu menu) {
        // Inflate the menu; this adds items to the action bar if it is present.
        getMenuInflater().inflate(R.menu.menu_zeta_d10_test, menu);
        return true;
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_settings) {
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
}
