package pl.elzab.virtualcomsample.dataobject;

import android.os.Parcel;
import android.os.Parcelable;

/**
 * Object that holds STX protocol error data.
 * @author ElzabSoft
 * @version 1.01
 */
public class StxErrorMessage implements Parcelable {
    /** stx error code */
    private String mErrorCode;
    /** stx error description */
    private String mErrorDesc;
    /** stx error text */
    private String mErrorText;

    /** parcel creator */
    public static final Parcelable.Creator CREATOR =
            new Parcelable.Creator() {
                @Override
                public StxErrorMessage createFromParcel(Parcel in) {
                    return new StxErrorMessage(in);
                }

                @Override
                public StxErrorMessage[] newArray(int size) {
                    return new StxErrorMessage[size];
                }
            };

    /** TODO dummy method */
    @Override
    public int describeContents() {
        return 0;
    }

    /** method that converts StxErrorMessage to Parcel
     * @param out output Parcel
     * @param flags flags
     */
    @Override
    public void writeToParcel(Parcel out, int flags) {
        out.writeString(mErrorCode);
        out.writeString(mErrorDesc);
        out.writeString(mErrorText);
    }

    /** constructor that converts Parcel to StxErrorMessage
     * @param in input parcel
     */
    public StxErrorMessage(Parcel in) {
        mErrorCode = in.readString();
        mErrorDesc = in.readString();
        mErrorText = in.readString();
    }

    @Override
    public String toString() {
        return mErrorCode + ": " + mErrorText;
    }

    /** getter */
    public String GetErrorCode() {
        return mErrorCode;
    }

    /** setter */
    public void SetErrorCode(String errorCode) {
        mErrorCode = errorCode;
    }

    /** getter */
    public String GetErrorDesc() {
        return mErrorDesc;
    }

    /** setter */
    public void SetErrorDesc(String errorDesc) {
        mErrorDesc = errorDesc;
    }

    /** getter */
    public String GetErrorText() {
        return mErrorText;
    }

    /** setter */
    public void SetErrorText(String errorText) {
        mErrorText = errorText;
    }

    /** setter */
    public StxErrorMessage() {
    }

    /** basic constructor */
    public StxErrorMessage(String errorCode, String errorDesc, String errorText) {
        SetErrorCode(errorCode);
        SetErrorDesc(errorDesc);
        SetErrorText(errorText);
    }
}
